;
;  Version:  1.1
;
;  Copyright 1999-2002 Altium BV
;
$CASE
		NAME _IICALL
;
?C51RTL_PR	SEGMENT	CODE COMMON
		RSEG	?C51RTL_PR
;
	PUBLIC	__IICALL
;************************************************************************
;									*
;	This routine provides a jump to a variable adress which		*
;	3 byte address is pointed to by DPTR. So a call to __IICALL	*
;       provides an indirect call to this user routine. This		*
;	implementation is required when bank switching is used.		*
;									*
;	Note: this routine should be adapted to match the particular	*
;	bank switch hardware used. This implemention assumes port P1	*
;	is used for bank switching.					*
;									*
;	destroys:	ALL						*
;									*
;************************************************************************
;

%IFNDEF(ARIT_UNIT)THEN(
%DEFINE(ARIT_UNIT)(0)
)FI
	
%IF(%EQS(%ARIT_UNIT,DALLAS_AA))THEN(
	BANK_SFR	EQU	AP
)ELSE(
	%IFDEF (CPU_c51f12x) THEN (
		BANK_SFR	EQU	PSBANK
	) ELSE (
		BANK_SFR	EQU	P1
	) FI
)FI

__IICALL:
	PUSH	BANK_SFR			; store the current bank
	CALL	_bankswitch
	POP		BANK_SFR			; switch back to original bank
	RET

_bankswitch:
	CLR		A
	MOVC	A,@A+DPTR		; get low 8-bits of function
	PUSH	ACC
	MOV 	A,#1
	MOVC	A,@A+DPTR		; get middle 8-bits of function
	PUSH	ACC
	MOV 	A, #2
	MOVC	A,@A+DPTR		; get bank (highest 8-bits) of function
	MOV 	BANK_SFR,A			;	2bytes ,return 
	RET		 				;  	1byte

	END
